#ifndef _CUSTOM_PROTOCOL_H_
#define _CUSTOM_PROTOCOL_H_

#define RESERVED_FIELD (0x00535049)

#define MSG_MCU_VERSION          (0x0100)
#define MSG_CAN_FILTER_VERSION   (0x0101)

enum a10_to_mcu_cmd
{
	
	MSG_CAN_FILTER = 1,
	MSG_KEEP_ALIVE,
	MSG_CAN_SET_OPMODE,
	MSG_CMD_M_READ_DATA,
	MSG_CAN_DATA_TRANSMIT,
};

enum mcu_to_a10_cmd
{
	MSG_SPI_INIT_RESPONSE   = 101,
	MSG_CAN_DATA,
	MSG_RES_S_READ_DATA,
};

enum debug_cmd
{
	// A10->MCU TEST CMD 
	MSG_TEST_MODE_ON = 201,
	MSG_TEST_MODE_OFF,
	MSG_POWCTRL_TEST,
	MSG_SPI_SLAVE_CLOSE,
	MSG_SPI_MASTER_TEST,
	MSG_CMD_CAN_TEST,
	MSG_MODE_DEBUG_ON,
	MSG_MODE_DEBUG_OFF,
	MSG_MCU_MASTER_TEST,
	// MCU->A10 TEST RESPONSE 
	MSG_RES_CAN_TEST = 301,
};
#if 0
enum
{
	/* A10->MCU CMD */
	MSG_SPI_COM_INIT = 0,
	MSG_CAN_FILTER			= 1,
	MSG_KEEP_ALIVE,
	MSG_CAN_SET_OPMODE,
	MSG_CMD_M_READ_DATA,
	MSG_CAN_DATA_TRANSMIT,
	MSG_CMD_RESET,
	MSG_CMD_PREPARE_RST,
	MSG_CMD_RELEASE,
	MSG_TIME_STAMP,
	/* MCU->A10 DATA Transfer */
	MSG_SPI_INIT_RESPONSE	= 101,
	MSG_CAN_DATA,
	MSG_RES_S_READ_DATA,
	/* A10->MCU TEST CMD */
	MSG_TEST_MODE_ON		= 201,
	MSG_TEST_MODE_OFF,
	MSG_POWCTRL_TEST,
	MSG_SPI_SLAVE_CLOSE,
	MSG_SPI_MASTER_TEST,
	MSG_CMD_CAN_TEST,
	MSG_MODE_DEBUG_ON,
	MSG_MODE_DEBUG_OFF,
	MSG_MCU_MASTER_TEST,
	/* MCU->A10 TEST RESPONSE */
	MSG_RES_CAN_TEST		= 301
};
#endif
typedef struct
{
	uint16_t type;
	uint16_t length;
	uint32_t reverved;
	uint64_t difff_time;
} headerType;

#endif

